#pragma once

#include <map>
#include "NewsFeed.h"

typedef std::map<ULONG, NewsFeedPtr> NewsFeedCache;

class CNewsFeedCache
{
public:
	~CNewsFeedCache() {};

	static void Load();
	static void Empty();
	static NewsFeedPtr GetNewsFeed(ULONG id);
	static NewsFeedPtr GetCommentFeed(ULONG itemID);
	static void AddFeed(NewsFeedPtr feed);
	static void RemoveFeed(ULONG feedId);
	static void GetAllNewsFeeds(NewsFeedVector& feeds);
	static int GetCommentFeeds(NewsFeedVector& commentFeeds, ULONG channelID);

private:
	CNewsFeedCache(){};

private:
	static NewsFeedCache m_newsFeedCache;
};
