!include "MUI2.nsh"
Name "GreatNews"
OutFile "GreatNews-1.0.xxx-Setup.exe"

SetCompressor lzma
SetCompressorDictSize 24

;default installation folder
;since our db is always stored along the exe, the default points to
;the current user's profile folder so there are no conflict with
;other greatnews users on the same machine
InstallDir "$LOCALAPPDATA\Curio Studio\GreatNews"

;load installation folder, if available
InstallDirRegKey HKCU "Software\Curio Studio\GreatNews" ""

;Request application privileges for Windows Vista
RequestExecutionLevel user

Var StartMenuFolder
!define MUI_ABORTWARNING

!insertmacro MUI_PAGE_LICENSE "..\bin\license.txt"
!insertmacro MUI_PAGE_DIRECTORY
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU" 
!define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\Curio Studio\GreatNews" 
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "GreatNews"
!insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
  
;languages
!insertmacro MUI_LANGUAGE "English"

Section "GreatNews" SecGreatNews

  SetOutPath "$INSTDIR"
  file "..\Release\GreatNews.exe"
  file "..\Release\GreatNewsDBMaint.exe"
  file "..\Release\GreatNewsUpdater.exe"
  file "..\bin\channels.opml"
  file "..\bin\greatnews_upgrade.ini"
  file "..\bin\license.txt"
  file "..\bin\newsfeed_upgrade.db"
  file "..\whatsnew.txt"
  SetOutPath "$INSTDIR\Language"
  file /r "..\bin\Language\gn_*.ini"
  ;file /r "..\Release\GreatNewsLngEditor.exe"
  SetOutPath "$INSTDIR\Media"
  file /r "..\bin\Media\*.*"
  SetOutPath "$INSTDIR\Favicons"
  SetOutPath "$INSTDIR\Plugins"
  file "..\Release\LiveWriterPlugin.dll"
  file "..\Release\wbloggarPlugin.dll"
  
  ;store installation folder
  WriteRegStr HKCU "Software\Curio Studio\GreatNews" "" $INSTDIR
  
  ;create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  ;"add/remove programs" entry
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GreatNews" "DisplayName" "GreatNews: The Intelligent RSS Reader"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GreatNews" "UninstallString" "$\"$INSTDIR\Uninstall.exe$\""  
  
  ;start menu shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\GreatNews.lnk" "$INSTDIR\GreatNews.exe"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
    !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

;uninstaller
Section "Uninstall"
  Delete "$INSTDIR\Uninstall.exe"
  RMDir /R "$INSTDIR"
  RMDir /R "$SMPROGRAMS\$StartMenuFolder"
  DeleteRegKey HKCU "Software\Curio Studio\GreatNews"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GreatNews"
SectionEnd
